# Intra-data source Relationships

{% hint style="success" %}
This is the official documentation of the `forestadmin/laravel-forestadmin` v2+ and `forestadmin/symfony-forestadmin` PHP agents.
{% endhint %}

We've seen that when building data sources, collections must fulfill the contract they defined [when declaring their capabilities](/developer-guide-agents-php/data-sources/custom/translation/capabilities.md).

The same is also true for [Intra-data source relationships](/developer-guide-agents-php/data-sources/custom/translation/structure.md#relationships) which are declared on the structure of a collection: declared relations must be handled when processing `filters`, `projection`, and `aggregations`.

## In practice

`one-to-many` and `many-to-many` relationships do not require additional work: Forest Admin will automatically call the destination collection with a valid filter.

On the other hand, `many-to-one` and `one-to-one` relationships require the implementer to make all fields from the target collection available on the source collection (under a prefix).

### Example

If a structure declaration contains the following statement

```php
class MyCollection extends Collection
{
    public function __construct(DatasourceContract $datasource)
    {
        parent::__construct(
            $datasource,
            'Movie'
        );

        // [...]

        $this->addField('director', new ManyToOneSchema(
            foreignKey: 'directorId',
            foreignKeyTarget: 'id',
            foreignCollection: 'People'
        ));
    }
}
```

Then the collection must accept references to fields from the `people` collection under the `director` prefix in all method parameters.

```php
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Caller;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\Nodes\ConditionTreeBranch;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\Nodes\ConditionTreeLeaf;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\PaginatedFilter;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Sort;

$dataSource->getCollection('Movie')->list(
    $caller,
    new PaginatedFilter(
        conditionTree: new ConditionTreeBranch(
            aggregator: 'and',
            conditions: [
                new ConditionTreeLeaf(
                    field: 'title',
                    operator: 'Equal',
                    value: 'E.T.'
                ),
                new ConditionTreeLeaf(
                    field: 'director:firstName',
                    operator: 'Equal',
                    value: 'Steven'
                ),
            ],
        ),
        sort: new Sort(
            [
               [
                  'field'     => 'director:birthDate',
                  'ascending' => true,
               ],
            ]
        )
    )
);
```

should return

```json
{
  "id": 34,
  "title": "E.T",
  "director": { "firstName": "Steven", "lastName": "Spielberg" }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-php/data-sources/custom/translation/relationships.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
